﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Npgsql;
using System.IO;
using System.Threading;

namespace Installer
{
    class Program
    {
        private static Timer dotts;
        static Program() {
            dotts = new Timer(new TimerCallback(Console.Write), ".", Timeout.Infinite, 500);
        }

        static void Main(string[] args){
            Console.Write("Login: ");
            string user = Console.ReadLine();
            Console.Write("Hasło: ");
            string pass = Console.ReadLine();

            int i = 0;
            string cstr = "Server=127.0.0.1;Port=5432;User Id=" + user + ";Password=" + pass + ";Database=tapflo;";
            NpgsqlCommand cmd;
            NpgsqlConnection conn = null;
            StreamReader sr = null;
            try {
                conn = new NpgsqlConnection(cstr);
                Console.Write("Łączenie ");
                dotts.Change(500, 500);
                
                conn.Open();
                StopDotts();
                Console.WriteLine("Połączono!");
                
                string l = null;
                sr = new StreamReader("cmd.sql");
                while ((l = sr.ReadLine()) != null){
                    cmd = new NpgsqlCommand(l, conn);
                    Console.Write(++i + " ");
                    dotts.Change(500, 500);
                    cmd.ExecuteNonQuery();
                    Thread.Sleep(100);

                    ClearLine();
                    cmd.Dispose();
                }

                Console.WriteLine("Pomyślnie zaktualizowano ({0})", i);
            }
            catch (NpgsqlException e){
                if (e.Code.StartsWith("28"))
                    Console.WriteLine("\nBłędny login lub hasło!");
                else if (e.Code.Length == 0)
                    Console.WriteLine("\nServer nie odpowiada");
                else
                    Console.WriteLine(" Error: {0}", e.Message);
            }
            catch (Exception e){
                Console.WriteLine("\nUnexpected Error: {0}\n", e.Message);
            }
            finally {
                StopDotts();
                if (conn != null)
                    conn.Close();
            }

            Console.WriteLine("Zamykanie...");
            Console.ReadKey();
        }

        private static void StopDotts() {
            dotts.Change(Timeout.Infinite, Timeout.Infinite);
            Console.WriteLine();
        }

        private static void ClearLine(){
            Console.SetCursorPosition(0, Console.CursorTop);
            Console.Write(new String(' ', Console.WindowWidth - 1));
            Console.SetCursorPosition(0, Console.CursorTop);
            dotts.Change(Timeout.Infinite, Timeout.Infinite);
        }
    }
}
