﻿CREATE OR REPLACE FUNCTION tapflodb.resetpassword(IN uid integer, IN newpass varchar(128)) 
	RETURNS INTEGER AS
$BODY$
DECLARE
    u tapflodb.userdata;
BEGIN
	-- Check user and old pass match
    SELECT * INTO u FROM tapflodb.userdata 
		WHERE id = uid;
	IF FOUND THEN
		IF u.mode & 1 THEN
			UPDATE tapflodb.userdata SET password = sha256(newpass::text), mode = mode & ~2 WHERE id = uid;
			IF FOUND THEN
				EXECUTE 'ALTER ROLE ' || u.login || ' ENCRYPTED PASSWORD ' || quote_literal(newpass) || ';';
				return 0; -- succesfully changed
			ELSE
				return 3; -- password update error
			END IF;
		ELSE
			return 2; --  not active user
		END IF;
    END IF;
    return 1; -- no user found
END;
$BODY$
	LANGUAGE plpgsql 
	VOLATILE NOT LEAKPROOF
	SECURITY DEFINER
	COST 100
    SET search_path = tapflodb, public, pg_temp;
ALTER FUNCTION tapflodb.resetpassword(IN integer, IN varchar)
  OWNER TO tapflo;
REVOKE ALL ON FUNCTION tapflodb.resetpassword(integer, varchar) FROM PUBLIC;
GRANT EXECUTE ON FUNCTION tapflodb.resetpassword(integer, varchar) TO tapflo;
GRANT EXECUTE ON FUNCTION tapflodb.resetpassword(integer, varchar) TO tapflodb;
