﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Npgsql;

namespace TapfloDB
{
    public partial class Password : Form
    {
        public Password(FormMode mode) : this(mode, null) { }
        public Password(FormMode mode, string old){
            InitializeComponent();
            if (mode == FormMode.Change){
                Text = "Wymagana jest zmiana hasła";
                told.Text = old;
                told.Enabled = false;
            }
        }

        private void bsave_Click(object sender, EventArgs e){
            if (told.Text.Length == 0 || tnew1.Text.Length == 0 || tnew2.Text.Length == 0){
                MessageBox.Show("Hasło nie może być puste!", "Puste Hasło", MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
                return;
            }

            if (tnew1.Text.Length < 6) {
                MessageBox.Show("Nowe hasło jest zbyt krótkie (minimum 6 znaków)", "Hasło zbyt krótkie", MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
                return;
            }

            if (told.Text == tnew1.Text){
                MessageBox.Show("Nowe hasłe nie może być takie same jak stare!", "Nowe Stare Hasło", MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
                tnew1.Focus();
                tnew1.Select(0, tnew1.Text.Length);
                return;
            }

            if (tnew1.Text != tnew2.Text){
                MessageBox.Show("Nowe hasła nie pasują do siebie!", "Podane hasła są różne", MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
                tnew1.Focus();
                tnew1.Select(0, tnew1.Text.Length);
                return;
            }

            if (!Server.Passwd(Session.Curr.User.ID, told.Text, tnew1.Text)) { 
                MessageBox.Show("Nie udało się zmienić hasła. Upewnij się że prawidłowo wprowadzasz stare hasło oraz że nowe spełnia wymagania nakładane na hasła.", "Hasło nie zostało zmienione", MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
                return;
            }

            DialogResult = DialogResult.OK;
        }
    }
}
