﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Configuration;

namespace TapfloDB.View.TDB
{
    public partial class LabelSettings : Form
    {
        Configuration config; 
        KeyValueConfigurationCollection settings;
        
        public LabelSettings(){
            InitializeComponent();

            config = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None);
            settings = config.AppSettings.Settings;

            tmx.Text = settings["ModelX"] == null ? LabelPrinter.ModelRect.X.ToString("0.##") : settings["ModelX"].Value;
            tmy.Text = settings["ModelY"] == null ? LabelPrinter.ModelRect.Y.ToString("0.##") : settings["ModelY"].Value;

            tsnx.Text = settings["SNX"] == null ? LabelPrinter.SNRect.X.ToString("0.##") : settings["SNX"].Value;
            tsny.Text = settings["SNY"] == null ? LabelPrinter.SNRect.Y.ToString("0.##") : settings["SNY"].Value;
        }

        private void bsave_Click(object sender, EventArgs e){
            // Set new values
            if (settings["ModelX"] == null) settings.Add("ModelX", tmx.Text);
            else settings["ModelX"].Value = tmx.Text;
            if (settings["ModelY"] == null) settings.Add("ModelY", tmy.Text);
            else settings["ModelY"].Value = tmy.Text;

            if (settings["SNX"] == null) settings.Add("SNX", tsnx.Text);
            else settings["SNX"].Value = tsnx.Text;
            if (settings["SNY"] == null) settings.Add("SNY", tsny.Text);
            else settings["SNY"].Value = tsny.Text;

            try {
                //save the file
                config.Save(ConfigurationSaveMode.Modified);

                //relaod the section you modified
                ConfigurationManager.RefreshSection(config.AppSettings.SectionInformation.Name);
                LabelPrinter.LoadSettings();

                Session.Curr.Action("Ustawienia wydruku etykiet zostały pomyślnie zapisane");
            }
            catch (Exception exp) {
                Server.Log("Błąd zapisywania konfiguracji - {1}", exp.Message);
            }

            Close();
        }

        private void Number_Validating(object sender, CancelEventArgs e){
            TextBox tb = sender as TextBox;
            float f;
            if (!float.TryParse(tb.Text, out f)){
                MessageBox.Show("Wprowadzony tekst nie jest poprawną wartością!", "Wprowadzono niepoprawną wartość", MessageBoxButtons.OK, MessageBoxIcon.Information);
                e.Cancel = true;
            }
            else
                tb.Text = f.ToString("0.##");
        }
    }
}
