﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Npgsql;
using System.Data;

namespace TapfloDB.View.TDB
{
    public class TDB
    {
        //public static Dictionary<int, string> Tests { get; private set; }
        public static List<string> Tests { get; private set; }
        public static DataTable TestDef { get; private set; }
        
        static TDB(){
            Server.Connect();
            TestDef = new DataTable();
            NpgsqlDataAdapter da = Server.DataAdapter("SELECT * FROM tdb.\"TestDefinition\" ORDER BY id;");
            da.Fill(TestDef);
            Server.Close();

            //Tests = new Dictionary<int, string>();
            Tests = new List<string>();
            foreach (DataRow tr in TestDef.Rows)
                //Tests.Add((int)tr["id"], (string)tr["name"]);
                Tests.Add((string)tr["name"]);
        }

        /// <summary>
        /// Get last iteration number for specified SN
        /// </summary>
        /// <param name="sn">Product Serial Number (SN)</param>
        /// <returns>Last iteration number or 0 if not tested product</returns>
        public static int LastIter(int sn){
            NpgsqlCommand cmd = Server.Command("SELECT max(nr) FROM tdb.\"TestDatabase\" WHERE sn = :sn;");
            cmd.Parameters.AddWithValue("sn", sn);

            object o = cmd.ExecuteScalar();
            return o is DBNull ? 0 : (short)o;
        }

        public static bool Accept(int sn, short nr){
            NpgsqlCommand cmd = Server.Command("UPDATE tdb.\"TestDatabase\" SET state = state | 1 WHERE sn = :sn AND nr = :nr;");
            cmd.Parameters.AddWithValue("sn", sn);
            cmd.Parameters.AddWithValue("nr", nr);

            return cmd.ExecuteNonQuery() > 0;
        }

        public static bool Delete(int sn, short nr){
            NpgsqlCommand cmd = Server.Command("DELETE FROM tdb.\"TestDatabase\" WHERE sn = :sn AND nr = :nr;");
            cmd.Parameters.AddWithValue("sn", sn);
            cmd.Parameters.AddWithValue("nr", nr);

            return cmd.ExecuteNonQuery() > 0;
        }
    }
}
