﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace Updater
{
    public class Logger : IDisposable
    {
        public static RichTextBox Box;
        public static Logger logger;

        public StreamWriter log;

        public static Logger Get(){
            if(logger == null)
                logger = new Logger();

            return logger;
        }

        private Logger(){
            log = new StreamWriter("update.log", true);
            log.AutoFlush = true;
            if (log.BaseStream.Length > 8)
                log.WriteLine(new String('-', 50));
        }

        public void Log(string format, params object[] args){
            string msg = String.Format(format, args);
            if (Box != null)
                Box.AppendText(msg + "\n");

            if (log != null)
                log.WriteLine("[{0} {1}] {2}", DateTime.Now.ToShortDateString(), DateTime.Now.ToLongTimeString(), msg);
        }
        
        public void  Dispose(){
            if (log != null)
                log.Close();
        }
    }
}
