﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Updater
{
    public partial class Login : Form
    {
        private Logger logger;

        public string UserName {
            get { return tlogin.Text; }
        }
        
        public string Password
        {
            get { return tpass.Text; }
        }

        public Login(){
            DialogResult = DialogResult.Abort;
            InitializeComponent();
            logger = Logger.Get();
        }

        private void Login_Shown(object sender, EventArgs e){
            tlogin.Focus();
        }

        private void blogin_Click(object sender, EventArgs e){
            if(tlogin.Text.Length == 0 || tpass.Text.Length == 0){
                MessageBox.Show("Login i/lub Hasło nie może być puste!", "Pusty Login/Hasło", MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
                return;
            }

            try {
                if (PGCmd.TryLogin(tlogin.Text, tpass.Text)){
                    DialogResult = DialogResult.OK;
                }
                else
                    MessageBox.Show("Błędny login lub hasło!", "Nieudane logowanie", MessageBoxButtons.OK, MessageBoxIcon.Warning);
            }
            catch {
                MessageBox.Show("Podczas próby logowania wystąpił nieoczekiwany błąd.\nSpróbuj ponownie za kilka minut jeśli ten błąd bedzie się powtarzał skontaktuj się z Administratorem.", "Nieoczekiwany błąd logowania.", MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
            }
        }
    }
}
