﻿-- TapfloDB version
CREATE OR REPLACE FUNCTION public.tapflodb() RETURNS TEXT AS $$
BEGIN
	RETURN '1.4';
END;
$$ LANGUAGE plpgsql;

-- public Access
REVOKE CREATE ON SCHEMA public FROM PUBLIC;
GRANT ALL ON SCHEMA public TO tapflo;

-- tdb Access
GRANT ALL ON SCHEMA tdb TO tapflo;
GRANT USAGE ON SCHEMA tdb TO tapflouser;

-- TestDatabase Access
ALTER TABLE tdb."TestDatabase" OWNER TO tapflo;
GRANT ALL ON TABLE tdb."TestDatabase" TO tapflo;
GRANT ALL ON TABLE tdb."TestDatabase" TO tapflouser;

-- TestDefinition Access
ALTER TABLE tdb."TestDefinition" OWNER TO tapflo;
GRANT ALL ON TABLE tdb."TestDefinition" TO tapflo;
GRANT SELECT ON TABLE tdb."TestDefinition" TO tapflouser;

-- TestFailGroups Access
ALTER TABLE tdb."TestFailGroups" OWNER TO tapflo;
GRANT ALL ON TABLE tdb."TestFailGroups" TO tapflo;
GRANT SELECT ON TABLE tdb."TestFailGroups" TO tapflouser;

-- TestFailReason Access
ALTER TABLE tdb."TestFailReason" OWNER TO tapflo;
GRANT ALL ON TABLE tdb."TestFailReason" TO tapflo;
GRANT SELECT ON TABLE tdb."TestFailReason" TO tapflouser;

-- Clean PG Users
CREATE OR REPLACE FUNCTION tapflodb.cleanpgusers() RETURNS integer AS $$
DECLARE
    count INTEGER := 0;
    usr TEXT;
BEGIN
    RAISE NOTICE 'Clean system users...';

    FOR usr IN SELECT u.usename FROM pg_catalog.pg_user u WHERE u.usename NOT IN('postgres', 'admin', 'tapflo', 'tapflodb', 'tapflouser') ORDER BY 1 LOOP
	--RAISE NOTICE 'acount %', quote_literal(usr);
        PERFORM * FROM tapflodb.userdata WHERE login = usr;
	IF NOT FOUND THEN
	    RAISE NOTICE 'Removing unknown acount %', quote_literal(usr);
	    EXECUTE 'DROP ROLE ' || usr;
            count := count + 1;
        END IF;
    END LOOP;

    RAISE NOTICE 'Done.';
    RETURN count;
END;
$$ LANGUAGE plpgsql;
